
package LEARNAgents;

import jade.core.Agent;
import jade.core.behaviours.CyclicBehaviour;
import jade.core.behaviours.TickerBehaviour;

import jade.util.leap.HashSet;
import jade.util.leap.Iterator;
import jade.util.leap.List;
import jade.util.leap.Set;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.apache.logging.log4j.ThreadContext;

import LEARNOntology.Execute;
import LEARNOntology.LEARNOntology;
import LEARNOntology.LEARNServiceDescription;
import LEARNOntology.PlatformDescription;
import LEARNOntology.WorkFor;
import LEARNOntology.impl.*;
import PlatformSelector.IPlatformSelector;
import PlatformSelector.MyPlatformDescription;
//import PlatformSelector.MyPlatformDescription;
import PlatformSelector.RandomSelector;
import jade.content.Concept;
import jade.content.ContentElement;
import jade.content.lang.Codec;
import jade.content.lang.Codec.CodecException;
import jade.content.lang.sl.SLCodec;
import jade.content.onto.Ontology;
import jade.content.onto.OntologyException;
import jade.content.onto.basic.Action;
import jade.content.onto.basic.Result;
import jade.core.AID;
import jade.domain.DFService;
import jade.domain.FIPAException;
import jade.domain.FIPANames;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.FIPAAgentManagement.ServiceDescription;
import jade.lang.acl.ACLMessage;
import jade.util.leap.ArrayList;
import jade.util.leap.Collection;
import jade.util.leap.HashMap;
import jade.util.leap.Map;
import jade.domain.FIPAAgentManagement.Property;


public class Assistant extends Agent {

	String serviceName = "unknown";
	String mioLN="";
	String serviceParam=""; // questa sarà una lista dentro serviceDesc
	LEARNServiceDescription myservice;
	int numOfMessages=0, mioID=0, numOfMessagesReceived=0;
	boolean singularly=true;
	String myPlatform;
	String myIP;
	boolean provatoInLocale=false;
	Set knownPlatforms=null;
	Map receivedMessages=null;
	TickerBehaviour t=null;
	IPlatformSelector pSel;
	
	private Codec codec = new SLCodec(); //FIPANames.ContentLanguage.FIPA_SL0; 
	private Ontology ontology = LEARNOntology.getInstance();
	private Logger logger;// = LogManager.getLogger(LEARNAMS.class);
    
  protected void setup() {
  	
	  getContentManager().registerLanguage(codec); //, FIPANames.ContentLanguage.FIPA_SL0);	
	  // Register the ontology used by this application
	  getContentManager().registerOntology(ontology);
		
	  knownPlatforms= new HashSet();
	  receivedMessages=new HashMap();
	  myPlatform=this.getContainerController().getPlatformName();
	  myIP=(String) getAMS().getAllAddresses().next();
	  pSel=new RandomSelector();
	  
	  ThreadContext.put("ROUTINGKEY", this.getName());
	  logger = LogManager.getLogger(this.getName());
	  
  	// Read the name of the service to register as an argument
  	Object[] args = getArguments();
  	if (args != null && args.length > 0) {
  		serviceName = (String) args[0];
  	}
  	
  	
  	addBehaviour(new CyclicBehaviour(this) 
    {
		
         public void action() 
         {
            ACLMessage msg= receive();
            if (msg!=null){
            	//System.out.println( "Sono " + myAgent.getName() + " e Ho ricevuto mess " + msg.getContent() + " da " + msg.getSender());
                
                // se è il service manager, dovrebbe essere il primo messaggio, la workfor
                if(msg.getSender().getLocalName().equals("SM")){
                	System.out.println("messaggio da SM con param " + msg.getContent() + " at " + System.currentTimeMillis());
                	
                	logger.trace("Message from Sm with content:" + msg.getContent());
                	//workFor(LEARNNodeA,ID,ServiceName,[ServiceParams],NumberOfAnswers,Singularly)
                	// workFor action
                	try{
                	
                		/*
	                	String[] params=msg.getContent().split(";");
	                	mioLN=params[0];
	                	mioID=Integer.parseInt(params[1]);
	                	serviceName=params[2];
	                	serviceParam=params[3];
	                	numOfMessages=Integer.parseInt(params[4]);
	                	singularly=Boolean.parseBoolean(params[5]);
	                	
	                	System.out.println("devo trovare " + numOfMessages + " " + serviceName + " per " + mioLN + ";" + singularly);
	            
	                	*/
                		ContentElement ce = null; 
						 try {
							ce=myAgent.getContentManager().extractContent(msg);
							Concept c = (Concept)((Action)ce).getAction();
							
							if(c instanceof WorkFor){
								mioLN=((WorkFor)c).getLearnNode().getLocalName();
			                	mioID=((WorkFor)c).getRequestID();
			                	
			                	// questi due andranno pian piano soppiantati dal ServiceDescription
			                	serviceName=((WorkFor)c).getRequestedService().getServiceName();
			                	// aggiungi parametro!!
			                	serviceParam=((WorkFor)c).getRequestedService().getServiceName();
			                	myservice=((WorkFor)c).getRequestedService();
			                	numOfMessages=((WorkFor)c).getNumRequestedResults();
			                	singularly=((WorkFor)c).getSingularly();
			                	
								invoke(((WorkFor)c).getNumRequestedResults());
							}
						}
						 catch(Exception e){
							 e.printStackTrace();
						 }
						 
	                	
                	}
                	catch(Exception e){
                		logger.trace("Error in parameters");
                	}

                }
                else if(msg.getSender().getLocalName().equals(mioLN)){
                	// qui è il mio capo che mi vuol dire qualcosa, per ora ancora non previsto
                }
                else if(msg.getSender().getLocalName().equals("LEARNAMS")){
                	// e' il mio LEARNAMS che mi manda l'elenco delle piattaforme
                	
                	System.out.println("Assistant: messaggio da LEARNAMS ");
                	logger.trace("Message from LEARNAMS with Platforms");// + msg.getContent());
                	extractPlatforms(msg);
                	invokeExternal(numOfMessages-numOfMessagesReceived, selectPlatformsSubSet(numOfMessages-numOfMessagesReceived));
                	
                }
                else if(msg.getSender().getLocalName().equals("ams")) {//if(msg.getSender().getLocalName().startsWith("LN")){
                	
                }
                else if(!msg.getSender().getLocalName().equals(myAgent.getLocalName())){ //if(msg.getSender().getLocalName().startsWith("LN")){
                	// assumo che i learn node si chiamino LN più qualcosa
                	System.out.println("messaggio da LN " + msg.getSender().getLocalName());
                	logger.trace("Message from LN "+ msg.getSender().getLocalName());
                	
                	if(numOfMessages>numOfMessagesReceived && !giaRicevuto(msg)){
                		// questo if mi serve perche' prima che si risvegli il behaviour che controlla se mi e' arrivato tutto,
            			// potrei ricevere, ed inoltrare, piu' mess di quelli che mi servivano
            			
        				if(singularly){
                			
            				ACLMessage inform= new ACLMessage(ACLMessage.INFORM);
                    		inform.setSender(myAgent.getAID());
                    		inform.setProtocol("invokeSings");
                    		// proviamo così
                    		//inform.addReceiver(new AID(mioLN,false));
                    		AID app=new AID(mioLN,true);
                    		// dato che non so bene se questo agente ha indirizzo, prendo anche quello dell'ams
                    		try{
                    			app.addAddresses(myAgent.getAID().getAddressesArray()[0]);
                    		}
                    		catch(Exception e){
                    			logger.trace("non trovo address mio");
                    		}
                    		try{
                    			app.addAddresses(myAgent.getAMS().getAddressesArray()[0]);
                    		}
                    		catch(Exception e){
                    			logger.trace("non trovo address AMS");
                    		}
            
                    		inform.addReceiver(new AID(mioLN,false));
                    		
                    		//
                    		
                    		inform.setContent(msg.getSender().getName() + ";" +msg.getContent());
                    		// qui non so bene dove dirgli chi ha fatto questo servizio, ora ci metto il nome del mittente... poi ci pensiamo
                    		
                    		logger.trace("send to the requesting source agent the single result: " + inform.getContent());
                    		 
                        	send(inform);
                        	
                        	numOfMessagesReceived++;
            			
                    	}
                    	else {
                    		// nella giaRicevuto l'ho aggiunto all'elenco dei mess ricevuti,
                    		// qui incremento semplicemente il numero
                    		numOfMessagesReceived++;
                    	}
            			
                	}

                }
            }
            
            else block();
         }
    });
  } 
  
  private void invoke(int numOfMessagesTBF){
	// questo però deve contenere un ciclo e continua ad andare sinchè non ho ricevuto le risposte che mi servono,
	// ma devo capire come gestirlo, quanto aspettare prima di ripartire a chiedere ad esempio,
	// e se tenere un elenco di chi mi ha risposto per scartare doppioni
	
	  if(numOfMessages<=numOfMessagesReceived){
		  logger.trace("All answers received, I stop my waiting");
		  // finished!
		  // in doDelete I send a mess to SM to inform him I finished.
		  // the LN has already been informed of the results (if singularly)
		  if(singularly) this.doDelete();
		  else{
			  // I inform my LN and send him the boundle with results
			  Collection ml=receivedMessages.values();
			  Iterator it=ml.iterator();
			  
			  	ACLMessage inform= new ACLMessage(ACLMessage.INFORM);		  
	      		inform.setSender(this.getAID());
	      		inform.setProtocol("invokeSings");
	      		
	      		// proviamo così
        		//inform.addReceiver(new AID(mioLN,false));
        		AID app=new AID(mioLN,true);
        		// dato che non so bene se questo agente ha indirizzo, prendo anche quello dell'ams
        		try{
        			app.addAddresses(getAID().getAddressesArray()[0]);
        		}
        		catch(Exception e){
        			logger.trace("non trovo address mio");
        		}
        		try{
        			app.addAddresses(getAMS().getAddressesArray()[0]);
        		}
        		catch(Exception e){
        			logger.trace("non trovo address AMS");
        		}
        		
	      		String s="[";
	      		while(it.hasNext()){
				  	ACLMessage n=(ACLMessage)it.next();
				  	s=s+ n.getSender().getName() + ";" + n.getContent() + ",";
		      		//inform.setContent(s+ n.getSender().getName() + ";" + n.getContent() + ",");
		      		// qui non so bene dove dirgli chi ha fatto questo servizio, ora ci metto il nome del mittente... poi ci pensiamo
		          	
	          	
			  }
			  inform.setContent(s.substring(0, s.length()-1) + "]");
			  logger.trace("send to the requesting source agent the results in boundle: " + inform.getContent());
			  
			  send(inform);
			  
	          this.doDelete();
		  }
		  
	  }
	  else if(!provatoInLocale){
		  ACLMessage localExe= new ACLMessage(ACLMessage.REQUEST);
		  localExe.setLanguage(codec.getName());
		  localExe.setOntology(ontology.getName());
		  localExe.setProtocol("execute");
		  localExe.addReceiver(new AID("SM",false));
		  //localExe.setContent(serviceName + ";" + serviceParam + ";" + numOfMessagesTBF + ";" + this.getName() + ";" + myIP);
		  //send(localExe);
		  
		  try {
			  Execute ex=new DefaultExecute();
			  ex.setNumRequestedResults(numOfMessagesTBF);
			  ex.setRequestedService(myservice);
			  
			  Action a = new Action();
			  a.setActor(new AID(getLocalName(), AID.ISLOCALNAME));
			  a.setAction(ex);
			  getContentManager().fillContent(localExe,a);	
			  
			  logger.trace("Try to search locally");
			  
			  send(localExe);		
				
			} catch (CodecException | OntologyException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} 
		  
		  provatoInLocale=true;
		  
		  // mi do' un po' di tempo pe aspettare le risposte in locale, che non so quante siano,
		  // e se quando mi risveglio non le ho tutte, passo alla parte globale
		  t = new TickerBehaviour(this, 3000) {
		      protected void onTick() {
		    	  if(numOfMessages==numOfMessagesReceived) {
		    		  logger.trace("Assitant ends its task! bye bye");
		    		  stop();
		    	  }
		    	  invoke(numOfMessages-numOfMessagesReceived);
		      }
			  
		  };
			    
			  
		  t.setFixedPeriod(true); 	    
		  addBehaviour(t);
	  }
	  else{
		  ACLMessage getPlat= new ACLMessage(ACLMessage.REQUEST);
		  getPlat.setProtocol("NetworkDiscoveryProtocol");
		  getPlat.addReceiver(new AID("LEARNAMS",false));
		  //localExe.setContent(serviceName + ";" + serviceParam + ";" + numOfMessagesTBF + ";" + this.getName() + ";" + myIP);
		  Action a = new Action();
		  a.setActor(new AID(getLocalName(), AID.ISLOCALNAME));
		  a.setAction(new DefaultGetKnownPlatforms());
		  getPlat.setLanguage(codec.getName());
		  getPlat.setOntology(ontology.getName());
							
			try {
				getContentManager().fillContent(getPlat,a);				
				send(getPlat);	
				logger.trace("LEARNAMS contacted to know new plat.");
				System.out.println( "Sono Assistant e ho mandato mess a learnams");
				
			} catch (CodecException | OntologyException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} 
			//send(getPlat);
	  }

  }
  
  
  private void invokeExternal(int numOfMessagesTBF, Set platSubSet){
	// qui ci arrivo quando il LEARNASM mi ha risposto, e ho già selezionato le piattaforme da contattare
	  
	  System.out.println("invoke external per number of service: " + numOfMessagesTBF);
	  logger.trace("invoke external for "+ numOfMessagesTBF + " results");
	  Iterator it  = platSubSet.iterator();
		
	  while (it.hasNext()) {
		  MyPlatformDescription i=(MyPlatformDescription) it.next();
		  ACLMessage extPlat= new ACLMessage(ACLMessage.REQUEST);
		  extPlat.setLanguage(codec.getName());
		  extPlat.setOntology(ontology.getName());
		  extPlat.setProtocol("execute");
		  logger.trace("	contact "+ i.getSM().toString());
		  System.out.println("mando a " + i.getSM().toString());
		  extPlat.addReceiver(i.getSM());
		  // qui il numero è ancora da capire dove e come decido di suddividerlo, per ora chiedo lo stesso numero a tutti i vicini nell'elenco gia' filtrato da chi mi ha chiamato
		  //extPlat.setContent(serviceName + ";" + serviceParam + ";" + numOfMessagesTBF + ";" + this.getName() + ";" + myIP);
		  //send(extPlat);
		  
		  try {
			  Execute ex=new DefaultExecute();
			  ex.setNumRequestedResults(numOfMessagesTBF);
			  ex.setRequestedService(myservice);
			  
			  Action a = new Action();
			  	// DANY
				// a.setActor(new AID(getLocalName(), AID.ISLOCALNAME));
			    AID globalAID=new AID(getName(),true);
			    try{
			    	globalAID.addAddresses(getAID().getAddressesArray()[0]);	
			    	
					}
				catch(Exception e){
					logger.trace("exception, no address found in me");
				}
			    
			    try{
			    	
			    	globalAID.addAddresses(getAMS().getAllAddresses().next().toString());	
					}
				catch(Exception e){
					logger.trace("exception, no address found in AMS");
				}
			    
			    a.setActor(globalAID);
			    //
				a.setAction(ex);
				getContentManager().fillContent(extPlat,a);				
				send(extPlat);		
				
			} catch (CodecException | OntologyException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} 
	  }

  }
  

  private boolean giaRicevuto(ACLMessage msg){
	  //return false;
	  
	  // qui se non sbaglio me lo dovrebbe inserire se e solo se non ho già quel mittente come chiave,
	  // cioè se non ho mai ricevuto mess da quel nodo
	  return receivedMessages.put(msg.getSender(),msg)!=null;
  }
  
  private void extractPlatforms(ACLMessage msg){

	  /*
	  if(list==null || list.equals("")) return;	
		
		// qui per ora assumo di avere sempre 3 parametri ben formati, quindi li leggo di 3 in 3
		String[] elem= list.split(";");
		
	  	knownPlatforms=new HashSet();
	  	
		for(int i=0;i<elem.length;i++){
			// se sono io non mi aggiungo alla lista
			//if(elem[i].equals(this.getContainerController().getPlatformName()) && elem[i+1].equals(getAMS().getAllAddresses().next())) break;
			//addPlatform(elem[i],elem[i+1],Integer.parseInt(elem[i+2]));
			
			// nome, IP
			if(knownPlatforms.add(new DefaultPlatformDescription(elem[i],elem[i+1]))) System.out.println(this.getLocalName() +": aggiunta piattaforma " + elem[i+1]);
			
			i=i+2;
		}
	  	
		printPlatforms();
		*/
	  
	  	ContentElement ce = null; 
		 try {
			ce=getContentManager().extractContent(msg);
			//System.out.println("mess ha tipo " + ce.getClass().toString());
			 
			if (ce instanceof Result) {
				knownPlatforms=new HashSet();
				Result result = (Result) ce;
		 						 
				 // guardo il contenuto e vedo se e' un set di descrizioni di piattaforma
				 if (result.getValue() instanceof HashSet){
					 if(!((HashSet)result.getValue()).isEmpty()){
						 if(((HashSet)result.getValue()).toArray()[0] instanceof DefaultPlatformDescription) { 
							 
							 Iterator i=((HashSet)result.getValue()).iterator();
							 
							 while(i.hasNext()){
								 DefaultPlatformDescription p=(DefaultPlatformDescription) i.next();
								 MyPlatformDescription mp=new MyPlatformDescription(p);
								 mp.createAgents();
								 knownPlatforms.add(mp);
							 }
						 
						 }
					 
					 }
					
				 }
			}
			printPlatforms();
			 
		} catch (CodecException | OntologyException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		 
		
	
  }
  
  private void printPlatforms(){
		//System.out.println(knownPlatforms.toString());
	  logger.trace("stampo piatt in lista: ");
	  Iterator it  = knownPlatforms.iterator();
		
	  while (it.hasNext()) {
		  String s=((MyPlatformDescription)it.next()).toString();
		  System.out.println(s);
		  logger.trace("	piatt: " + s);
	  }
  }
 
  private Set selectPlatformsSubSet(int num){
	  // questa sarà poi da parametrizzare
	  //return knownPlatforms;
	  
	  return pSel.getSubList(knownPlatforms, num);
  }


	@Override
	public void doDelete() {
		
		
		if(t!=null){
			this.removeBehaviour(t);
		  	this.removeTimer(t);
			t.stop();
		}
			
		ACLMessage finito= new ACLMessage(ACLMessage.INFORM);
		finito.setProtocol("invokeSing");
		
		// questo giusto local, e' sulla mia piattaforma
		finito.addReceiver(new AID("SM",false));
		//finito.addReceiver(new AID("SM",true));
		
		finito.setContent("Finished");
		send(finito);
		
		logger.trace("bye bye");
		System.out.println("ASSISTANT ENDS at " + System.currentTimeMillis());
		super.doDelete();
		//doDelete();
	}
  
  
  
}

