package LEARNAgents;

import java.io.FileReader;
import java.io.IOException;
//import java.util.ArrayList;

//import java.util.HashSet;
//import java.util.Set;
import com.opencsv.CSVReader;

import PlatformSelector.IPlatformSelector;
import PlatformSelector.MyPlatformDescription;
//import PlatformSelector.MyPlatformDescription;
import PlatformSelector.RandomSelector;
import jade.core.AID;
import jade.core.Agent;
import jade.core.behaviours.CyclicBehaviour;
import jade.core.behaviours.TickerBehaviour;
import jade.domain.AMSService;
import jade.domain.FIPAException;
import jade.lang.acl.ACLMessage;
import jade.lang.acl.MessageTemplate;
import jade.util.leap.Collection;
import jade.util.leap.HashSet;
import jade.util.leap.Iterator;
import jade.util.leap.ArrayList;
import jade.util.leap.Set;

import org.apache.logging.log4j.Logger;
import org.apache.logging.log4j.Level;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.ThreadContext;
import jade.content.lang.Codec;
import jade.content.lang.Codec.CodecException;
import jade.content.*;
import jade.content.abs.*;
import jade.content.onto.*;
import jade.content.onto.basic.*;
import jade.content.lang.sl.*;
import LEARNOntology.*;
import LEARNOntology.impl.*;
//import LEARNOntology.impl.DefaultGetKnownPlatforms;
//import LEARNOntology.impl.DefaultPlatformDescription;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.ThreadContext;

public class LEARNAMS extends Agent {

	private HashSet knownPlatforms;
	private HashSet deletedPlatforms;
	private String config="";
	private String myPlatform="";
	// by now, I'll directly keep here the ontology representation
	private DefaultPlatformDescription myOntoPlatform;
	private MessageTemplate templateNDP = MessageTemplate.MatchProtocol("NetworkDiscoveryProtocol");
	private MessageTemplate templateRegPlat = MessageTemplate.MatchProtocol("RegisterPlatform");
	
	// da passare poi come parametro
	private int networkDimension=5;
	private int updateRate=3000;
	private int NumPlatformsTBC=5;
	IPlatformSelector pSel;
	
	// -1 vuol dire gira senza limite
	private int numCycles=-1;
	
	// questo lo uso per contare quanti giri ho fatto
	private int cyclesDone=0;
	
	// futuri parametri?
	// dopo maxFailures risposte dall'AMS che un agente LEARNAMS e' morto, lo sposto nella lista dei morti
	private int maxFailures=1;
	// e ce lo lascio per maxIgnoreTime (giri del protocollo di update piattaforme), poi lo rimuovo dalla lista
	private int maxIgnoreTime=10;
	
	private Logger logger;
    
	private Codec codec = new SLCodec(); //FIPANames.ContentLanguage.FIPA_SL0; 
	private Ontology ontology = LEARNOntology.getInstance();
	private long millStart;

	
	protected void setup() {
		
		getContentManager().registerLanguage(codec); 	
		// Register the ontology used by this application
		getContentManager().registerOntology(ontology);
		
		ThreadContext.put("ROUTINGKEY", this.getName());
		
		logger = LogManager.getLogger(this.getName());
		//logger.trace("Entering application.");
		
		// anche questo volendo potrebbe essere un parametro
		pSel=new RandomSelector();
		
		knownPlatforms= new HashSet(); //<DefaultPlatformDescription>();
		deletedPlatforms= new HashSet(); //<DefaultPlatformDescription>();
		
		try{
			Object[] args = getArguments();
		  	if (args != null && args.length > 0) {
		  		config = (String) args[0];
		  		networkDimension=Integer.parseInt((String) args[1]);
		  		NumPlatformsTBC=Integer.parseInt((String) args[2]);
		  		numCycles=Integer.parseInt((String) args[3]);
		  	}
		}
		catch(Exception e){
			logger.trace("Error in input parameters: ");
			logger.trace(e.toString());
		}
		
		myPlatform=this.getContainerController().getPlatformName() +";" + getAMS().getAllAddresses().next() + ";231321";
		myOntoPlatform=new DefaultPlatformDescription();
		myOntoPlatform.setPlatformName(this.getContainerController().getPlatformName());
		myOntoPlatform.setPlatformIP(getAMS().getAllAddresses().next().toString());
		// messa di default per ora
		myOntoPlatform.setPlatformPort(1111);
		
		readPlatforms(config);
		printPlatforms();
		
		logger.trace(this.getName() + " starts, my networkDimension is " + networkDimension + " and I'll contact " + NumPlatformsTBC + " for cycles: " + numCycles);
		System.out.println("I'm " + this.getName() + " my networkDimension is " + networkDimension + " and I'll contact " + NumPlatformsTBC + " for cycles: " + numCycles);
		 //this.getContainerController().getPlatformName());
		
		//System.out.println("I'm " + this.getName() +myPlatform);
				
		addBehaviour(new CyclicBehaviour(this) {
			public void action() {
				ACLMessage msg = myAgent.receive(templateNDP);
				if (msg != null) {
					if(!msg.getSender().getName().startsWith("ams")){
						//e' un SM o un Assistant che mi sta sta chiedendo le piattaforme note
						if(msg.getPerformative()==ACLMessage.REQUEST && (msg.getSender().getName().startsWith("SM") || msg.getSender().getName().startsWith("Assistant"))){
							sendPlatformsList(msg);
						}
						// questo e' un LEARNAMS che sta facendo il protocollo completo
						else if(msg.getPerformative()==ACLMessage.REQUEST && msg.getSender().getName().startsWith("LEARNAMS")){
							System.out.println("I'm " + myPlatform.toString() + ". Received request from agent "+msg.getSender().getName() + msg.getSender().getAddressesArray()[0]);
							logger.trace("RECEIVED REQUEST FROM: " + msg.getSender().getName());
							sendPlatformsList(msg);
							// in the received platform list, the sender is not included, but
							// in a property of the Action there is the sender description -->
							// I add him to my list
							 ContentElement ce = null; 
							 try {
								ce=myAgent.getContentManager().extractContent(msg);
								Concept c = (Concept)((Action)ce).getAction();
								
								// deve essere questo, ma per sicurezza...
								 if(c instanceof GetKnownPlatforms){
									 MyPlatformDescription p=new MyPlatformDescription((DefaultPlatformDescription)((GetKnownPlatforms)c).getSenderPlatformData());
									 updateList(p);
								 }
							} catch (CodecException | OntologyException e) {
								// TODO Auto-generated catch block
								e.printStackTrace();
							}
							
						}
						// e' la risposta alla mia query
						else if(msg.getPerformative()==ACLMessage.INFORM && msg.getSender().getName().startsWith("LEARNAMS")){
							//logger.trace("I'm " + myAgent.getName() + ". Received INFORM from agent "+msg.getSender().getName());
							updateList(msg);
							
							printPlatforms();
						}
						
					}
					else {
						// qui dovrebbe essere l'AMS che mi dice che non trova l'agente (e' morto)
						// OK, e ci finisco quando una piattaforma che prima funzionava ora non mi risponde piu'
						// ( (action ( agent-identifier :name LEARNAMS@Platform3  :addresses (sequence http://149.132.172.53:60764/acc )) (ACLMessage) ) (MTS-error ( agent-identifier :name LEARNAMS@Platform4  :addresses (sequence http://149.132.172.53:60765/acc )) (internal-error "Foreign agent unreachable: No valid address contained within the AID LEARNAMS@Platform4")) )
						
						//logger.trace("MESSAGGIO DA AMS:" + msg.getContent() + " con performative " + msg.getPerformative());
						try {
							String s=AMSService.getFailedReceiver(myAgent, msg).getName();
							DefaultPlatformDescription pd=new DefaultPlatformDescription();
							pd.setPlatformName(s.substring(s.indexOf('@')+1,s.length()));
							pd.setPlatformIP(AMSService.getFailedReceiver(myAgent, msg).getAddressesArray()[0]);
							//logger.trace(pd.getName());
							updateFailure(new MyPlatformDescription(pd));
						} catch (FIPAException e) {
							// ERRORE, PERFORMATIVE 6 (FAILURE) MI ARRIVA QUI NEL CATCH, NON CAPISCO BENE PERCHE'...
							// QUESTA MI PORTA QUI... qui ci arriva quando la piattaforma1 è proprio inesistente, non l'ho MAI trovata --> arrivo qui
							// ( (action ( agent-identifier :name LEARNAMS@Platform4  :addresses (sequence http://149.132.172.53:61466/acc )) (ACLMessage) ) (MTS-error ( agent-identifier :name LEARNAMS@Platform1  :addresses (sequence http://149.132.172.53:7778/acc )) (internal-error "Agent not found: getContainerID() failed to find agent LEARNAMS@Platform1")) )
							// IN REALTA' CREDO CHE SI POSSA FINIRE QUI SOLO SE LA PIATTAFORMA1 E' GIU', E QUINDI FORSE VA BENE LO STESSO, PERCHE' SE LA CANCELLASSI CIAO, NON MI CONNETTERO' MAI PIU'... QUINDI SE FINISCO QUI LASCIO CMQ PIATTAFORMA1 nella lista, sperando si palesi
							System.out.println("non era un failure...?" + msg.getPerformative() + " " + msg.getContent());
							//logger.trace("non era un failure...?" + msg.getPerformative() + " " + msg.getContent());
							e.printStackTrace();
							
						}
						catch (Exception e) {
							// ERRORE, PERFORMATIVE 6 (FAILURE) MI ARRIVA QUI NEL CATCH, NON CAPISCO BENE PERCHE'...
							// QUESTA MI PORTA QUI... qui ci arriva quando la piattaforma1 e' proprio inesistente, non l'ho MAI trovata --> arrivo qui
							// ( (action ( agent-identifier :name LEARNAMS@Platform4  :addresses (sequence http://149.132.172.53:61466/acc )) (ACLMessage) ) (MTS-error ( agent-identifier :name LEARNAMS@Platform1  :addresses (sequence http://149.132.172.53:7778/acc )) (internal-error "Agent not found: getContainerID() failed to find agent LEARNAMS@Platform1")) )
							// IN REALTA' CREDO CHE SI POSSA FINIRE QUI SOLO SE LA PIATTAFORMA1 E' GIU', E QUINDI FORSE VA BENE LO STESSO, PERCHE' SE LA CANCELLASSI CIAO, NON MI CONNETTERO' MAI PIU'... QUINDI SE FINISCO QUI LASCIO CMQ PIATTAFORMA1 nella lista, sperando si palesi
							System.out.println("altro errore, catturato ");
							//logger.trace("non era un failure...?" + msg.getPerformative() + " " + msg.getContent());
							e.printStackTrace();
							
						}
					}
				}
				
				msg = myAgent.receive(templateRegPlat);
				if (msg != null) {
					String c=msg.getContent();
					String[] param=c.split(";");
					addPlatform(param[0], param[1], Integer.parseInt(param[2]));
				}
				else {
					block();
				}
			}
		} );
		
		// Add the TickerBehaviour 
		millStart=System.currentTimeMillis();
		TickerBehaviour t = new TickerBehaviour(this, updateRate) {
		      protected void onTick() {
		    	  
		    	  if(numCycles!=-1 && numCycles<=cyclesDone){
		    		  removeBehaviour(this);
		    	  }
			        searchForNeighbours();
			      } 
			    };
		t.setFixedPeriod(true); 	    
		addBehaviour(t);
	}
	
	// cerco la piattaforma, incremento il suo numero di failures, e se raggiunge il limite sposto la piattaforma in quelle morte
	private void updateFailure(MyPlatformDescription pd){
		ArrayList app= new ArrayList();
		
		Iterator it=knownPlatforms.iterator();
		while(it.hasNext()){
			MyPlatformDescription i=(MyPlatformDescription) it.next();
			if(i.equals(pd)) {
				
				i.increaseNumFailures();
				logger.trace("Not responding platform found: " + i.getPlatformName() + ", num failures " + i.getNumFailures());
				if(i.getNumFailures()==maxFailures) {
					// non si puo' fare in un iterator
					// knownPlatforms.remove(i);
					app.add(i);
					deletedPlatforms.add(i);
					//logger.trace("REMOVED PLATFORM " + i.getPlatformName());
					System.out.println("Removed platform " + i.getPlatformName());
					logger.trace("Removed " + i.getPlatformName());
					return;
				}
			}
		}
		knownPlatforms.removeAll(app);
		app=null;
		
		printPlatforms();
	}
	
	// ciclo sulla lista delle piattaforme morte, incremento ogni elemento (campo deadFrom),ed elimino dalla lista
	// quelli che sono morti da (cioe' li rendo nuovamente inseribili nelle piattaforme note)
	private void updateRemovedList(){
		ArrayList app= new ArrayList();
		
		//System.out.println("Cerco " + pd.toString());
		Iterator it=deletedPlatforms.iterator();
		//for(DefaultPlatformDescription i: deletedPlatforms){
		while(it.hasNext()){
			//logger.trace("Trovata piattaforma " + pd.getName());
			MyPlatformDescription i=(MyPlatformDescription) it.next();
			i.increaseDeadFrom();
			//logger.trace("Trovata piattaforma " + i.getName() + ", num failure " + i.getIncreaseNumFailures());
			if(i.getDeadFrom()==maxIgnoreTime) {
				//logger.trace("Removing platform from NotRespondingList: " + i.getPlatformName());
				
				// questa istruzione e' sbagliata da fare dentro in iteratore...
				//deletedPlatforms.remove(i);
				app.add(i);
				
				// non la sposto nella lista id quelle note, ma semplicemente smetto di non riaggiungerla, se qualcuno mi manda il suo IP
				System.out.println("Non piu' morta piattaforma " + i.getPlatformName());
				return;
			}
			
		}
		deletedPlatforms.removeAll((Collection) app);
		app=null;
		
	}
	
	private void readPlatforms(String file){

		CSVReader reader;
		try {
			// "bin/LEARNAgents/KnownPlatforms.cvs"
			reader = new CSVReader(new FileReader(file), '\t');
			String [] nextLine;
		     while ((nextLine = reader.readNext()) != null) {
		        // nextLine[] is an array of values from the line
		        // System.out.println(nextLine[0] + nextLine[1] + nextLine[2]);
		        //knownPlatforms.add(new PlatformDescription(nextLine[0],nextLine[1],Integer.parseInt(nextLine[2])));
		    	 addPlatform(nextLine[0],nextLine[1],Integer.parseInt(nextLine[2]));
		     }
		} catch (IOException e) {
			// TODO Auto-generated catch block
			logger.trace(e.getMessage());
			e.printStackTrace();
		}
		//logger.trace("letto file");
	
	}
	
	private void addPlatform(MyPlatformDescription platformDescription){
		if(networkDimension==knownPlatforms.size()) return;
		if(platformDescription==null) return;
		
		// I do not want to add myself to this list!!
		if(MyPlatformDescription.compareOntoPlat(platformDescription.getOntoP(), myOntoPlatform)) return;
		
		// already done in the calling method
		//platformDescription.createAgents();
		if(!deletedPlatforms.contains(platformDescription)){
			if(knownPlatforms.add((MyPlatformDescription) platformDescription)) {
				System.out.println(this.getLocalName() +": added platform " + platformDescription.getPlatformName());
				//logger.trace("added platform " + platformDescription.toString());
			}
			else ;//logger.trace("platform already in list:" + platformDescription.toString());
		}
		else ;//logger.trace("platform in notResponding list:" + platformDescription.toString());
	}
	
	// aggiungo una nuova piattaforma con questi dati, SE non e' fra quelle cancellate da poco
	private void addPlatform(String name, String IP, int port){
		
		MyPlatformDescription newP=new MyPlatformDescription(name, IP,port,name);
		newP.createAgents();
		addPlatform(newP);
	}
	
	private void printPlatforms(){
		//System.out.println(knownPlatforms.toString());
		Iterator it =knownPlatforms.iterator();
		while(it.hasNext()){
			System.out.println(((MyPlatformDescription)it.next()).toString());
			
		}
	}
	
	
	// di appoggio per logger
	private String serializePlatforms(){
		// vecchio, prima di ontologie
		String myList="";
		Iterator it =knownPlatforms.iterator();
		while(it.hasNext()){
			myList=myList+"\n"+(((MyPlatformDescription)it.next()).toString());
		}
		return myList;
		
	}
	
	
	private void updateList(ACLMessage msg){
		 ContentElement ce = null; 
		 try {
			ce=getContentManager().extractContent(msg);
			//logger.trace("Received message content: " + msg.getContent().toString());
			 
			if (ce instanceof Result) {
					 
				 Result result = (Result) ce;
		 						 
				 // I should receive a Set of PlatformDescription (ontology)
				 if (result.getValue() instanceof Set && !((HashSet)result.getValue()).isEmpty() && ((HashSet)result.getValue()).toArray()[0] instanceof DefaultPlatformDescription) { 
				 
					 //List list = result.getItems();
					 //Iterator i=list.iterator();
					 //logger.trace("num platform received: " + ((HashSet)result.getValue()).size());
					 Iterator i=((HashSet)result.getValue()).iterator();
					 
					 while(i.hasNext()){
						 DefaultPlatformDescription op=(DefaultPlatformDescription)i.next();
						 //logger.trace("analizzo piattaforma " + op.getPlatformName());
						 // I need to create a MyPlatDesc ob, with the ontological element inside, and I add this new object to my list
						 MyPlatformDescription p=new MyPlatformDescription(op);
						 p.createAgents();
						 updateList(p);
					 }
				 }
			}
			 
		} catch (CodecException | OntologyException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		 
		
	}
		
	private void updateList(MyPlatformDescription platformDescription){
		addPlatform(platformDescription);
		
	}
	
	private void searchForNeighbours(){
		// qui per limitare in numero di messaggi scambiati, seleziono solo NumPlatformsTBC vicini cui chiedere update.
		// uso un oggetto PlatformSelector per farmi dare il sottoinsieme di piattaforme
		
		// prima rimuovo quelli morti da troppo tempo
		updateRemovedList();
		//logger.trace(getName() + " sono nella search, current cyclesDone " + cyclesDone);
		if(numCycles==-1 || numCycles>cyclesDone){
			// -1 vuol dire gira senza fine --> faccio tutto quello che facevo prima
			// seleziono una sottoinsime di quelli che conosco, e chiedo a loro update
			jade.util.leap.Set subL=pSel.getSubList(knownPlatforms, NumPlatformsTBC);
			
			cyclesDone++;
			logger.trace("Started NDP num " + cyclesDone + ";" + System.currentTimeMillis());
			
			Iterator it  = subL.iterator();
			/*
			while (it.hasNext()) {
				ACLMessage msg= new ACLMessage(ACLMessage.REQUEST);
				msg.setContent(myPlatform);
				msg.addReceiver(((DefaultPlatformDescription)it.next()).getLEARNAMS());
				msg.setProtocol("NetworkDiscoveryProtocol");
				send(msg);
				logger.trace("chiesto update a " + ((AID)msg.getAllReceiver().next()).getName());
			}
			*/
			//System.out.println( "Sono LEARNams, avevo in lista " + knownPlatforms.size() + " e me ne hanno resituito " + subL.size());
			while (it.hasNext()) {
				Action a = new Action();
				GetKnownPlatforms gnp= new DefaultGetKnownPlatforms();
				gnp.setSenderPlatformData(myOntoPlatform);
				// questo parametro per ora non lo uso
				gnp.setMaxNum(10);
				a.setActor(new AID(this.getLocalName(), AID.ISLOCALNAME));
				a.setAction(gnp);
				ACLMessage mess=new ACLMessage(ACLMessage.REQUEST);
				mess.addReceiver(((MyPlatformDescription)it.next()).getLEARNAMS());
				
				mess.setProtocol("NetworkDiscoveryProtocol");
				mess.setLanguage(codec.getName());
				mess.setOntology(ontology.getName());
								
				try {
					getContentManager().fillContent(mess,a);				
					send(mess);	
					
					System.out.println(getName() + ": current num cycles " + cyclesDone);
					System.out.println( "Sono learnams e ho mandato mess a learnams " + mess.getAllReceiver().next());
					logger.trace("	Sent REQUEST TO: " + ((AID)mess.getAllReceiver().next()).getName());
				} catch (CodecException | OntologyException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} 
			}
			
		}
		else{
			System.out.println("All cycles done");
			logger.trace("All cycles done;" + System.currentTimeMillis() + ": tot millisec: " + (System.currentTimeMillis()- millStart));
		}
		
		
	}
    
	private void sendPlatformsList(ACLMessage msg) {
		ACLMessage reply = msg.createReply();
		reply.setPerformative(ACLMessage.INFORM);

		ContentElement ce = null; 
		 try {
			ce=getContentManager().extractContent(msg);
			Concept c = (Concept)((Action)ce).getAction();
			
			// I can only send elem from ontology, so I have to retrieve the PlatDesc into MyPlatDesc
			HashSet h= getOntoElem(knownPlatforms);
			Result result = new Result(c, h);
			 		
			 getContentManager().fillContent(reply, result);
			 
			 //logger.trace("reply to LEARNAMS with content: " + reply.getContent());
			 logger.trace("	Sent INFORM TO: " + ((AID)reply.getAllReceiver().next()).getName());
			 //logger.trace("	content: " + serializePlatforms());
			 send(reply);
			 
		} catch (CodecException | OntologyException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		} 
		send(reply);
	}
	
	private HashSet getOntoElem(HashSet knownPlatforms){
		HashSet ret =new HashSet();
		Iterator it=knownPlatforms.iterator();
		while(it.hasNext()){
			MyPlatformDescription elem=(MyPlatformDescription)it.next();
			ret.add(elem.getOntoP());
		}
			
		return ret;
	}
	
}
