
package LEARNAgents;

import jade.core.Agent;
import jade.core.behaviours.CyclicBehaviour;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.apache.logging.log4j.ThreadContext;

import LEARNOntology.LEARNOntology;
import LEARNOntology.impl.DefaultGetKnownPlatforms;
import PlatformSelector.IPlatformSelector;
import jade.content.lang.Codec;
import jade.content.lang.Codec.CodecException;
import jade.content.lang.sl.SLCodec;
import jade.content.onto.Ontology;
import jade.content.onto.OntologyException;
import jade.content.onto.basic.Action;
import jade.content.onto.basic.Result;
import jade.core.AID;
import jade.domain.DFService;
import jade.domain.FIPAException;
import jade.domain.FIPANames;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.FIPAAgentManagement.ServiceDescription;
import jade.lang.acl.ACLMessage;
import jade.util.leap.HashSet;
import jade.domain.FIPAAgentManagement.Property;


public class LEARNNode extends Agent {

	private HashSet receivedRequests=new HashSet();
	private Codec codec = new SLCodec(); //FIPANames.ContentLanguage.FIPA_SL0; 
	private Ontology ontology = LEARNOntology.getInstance();
	  //FileWriter fstream;// = new FileWriter("treno.txt");
	  //BufferedWriter out; //= new BufferedWriter(fstream);
	  public static String newline;
		private Logger logger;// = LogManager.getLogger(LEARNAMS.class);
		 
  protected void setup() {
  	
      try{
          // Create file
          //fstream = new FileWriter(".//logs//" + this.getName() + ".txt");
          //out = new BufferedWriter(fstream);
          newline = System.getProperty("line.separator");
          
          ThreadContext.put("ROUTINGKEY", this.getName());
    	  logger = LogManager.getLogger(this.getName());
    	  

          }
        catch (Exception e){//Catch exception if any
            System.err.println("ErrorE FILE: " + e.getMessage());
          }

	  getContentManager().registerLanguage(codec); //, FIPANames.ContentLanguage.FIPA_SL0);	
	  // Register the ontology used by this application
	  getContentManager().registerOntology(ontology);
		
	  String serviceName = "s1";
  	
  		// Read the name of the service to register as an argument
  		Object[] args = getArguments();
  		if (args != null && args.length > 0) {
  			serviceName = (String) args[0];
  		}
  	
  		// Register the service
  		System.out.println("Agent "+getName()+" registering service \""+serviceName+"\" of type \"LEARN\"");
  		try {
	  		DFAgentDescription dfd = new DFAgentDescription();
	  		dfd.setName(getAID());
	  		ServiceDescription sd = new ServiceDescription();
	  		sd.setName(serviceName);
	  		sd.setType("LEARN");
	  		// Agents that want to use this service need to "know" the weather-forecast-ontology
	  		sd.addOntologies("ServiceOnto");
	  		// Agents that want to use this service need to "speak" the FIPA-SL language
	  		sd.addLanguages(FIPANames.ContentLanguage.FIPA_SL);
	  		sd.addProperties(new Property("country", "Italy"));
	  		dfd.addServices(sd);
	  		
	  		DFService.register(this,dfd);
	  		
	  	}
	  	catch (FIPAException fe) {
	  		fe.printStackTrace();
	  	}
  	
  		addBehaviour(new CyclicBehaviour(this) 
  		{
		
         public void action() 
         {
            try{
            ACLMessage msg= receive();
            if (msg!=null){
            	System.out.println( "Sono " + myAgent.getName() + " e Ho ricevuto mess " + msg.getContent() + " da " + msg.getSender());
                
            	if(msg.getContent()!= null && msg.getPerformative()== ACLMessage.PROPOSE){
            		Action a = new Action();
					a.setActor(new AID(myAgent.getLocalName(), AID.ISLOCALNAME));
					a.setAction(new DefaultGetKnownPlatforms());
					ACLMessage mess=new ACLMessage(ACLMessage.PROPOSE);
					mess.addReceiver(new AID("LEARNAMS",false));
					mess.setProtocol("NetworkDiscoveryProtocol");
					mess.setLanguage(codec.getName());
					mess.setOntology(ontology.getName());
        							
        			try {
        				getContentManager().fillContent(mess,a);				
        				send(mess);		
        				System.out.println( "Sono learnonode e ho mandato mess a learnams");
        				
        			} catch (CodecException | OntologyException e) {
        				// TODO Auto-generated catch block
        				e.printStackTrace();
        			} 
        			
            	}
            	
                // qui poi sarà da fare una receive ben più pulita, ma er ora ci mettiamo questo
                if(msg.getContent()!= null && msg.getContent().contains("s1")){
                	// se e' il messaggio di un assistant, rispondo se e solo se non mi era gia' arrivato (altrimenti gli ho gia' risposto)
                	if(msg.getAllReplyTo().next().toString().contains("Assistant_") && receivedRequests.add(msg.getContent() + ";" + msg.getAllReplyTo().next().toString())){ //msg.getAllReplyTo().next().toString()) ){
                		System.out.println("rispondo ad assistant " + msg.getAllReplyTo().next().toString());
                    	// dovrebbe rispondere direttamente al replyTo
                    	ACLMessage mess=msg.createReply();
            			mess.setPerformative(ACLMessage.INFORM);
            			mess.setContent("fatto");
            			//mess.addUserDefinedParameter(key, value);
            			send(mess);
            			logger.trace("Answer to service execution for " + mess.getAllIntendedReceiver().next().toString());
            			  
                	}
                	else if(!msg.getAllReplyTo().next().toString().contains("Assistant_")){
                    	// qui poi bisognera' capire che fare in caso siano altri agenti a contattarmi
                		
                		System.out.println("rispondo a " + msg.getAllReplyTo().next().toString());
                		
                		
                    	// dovrebbe rispondere direttamente al replyTo
                    	ACLMessage mess=msg.createReply();
            			mess.setPerformative(ACLMessage.INFORM);
            			mess.setContent("fatto");
            			//mess.addUserDefinedParameter(key, value);
            			send(mess);
            			logger.trace("Answer to " + mess.getAllIntendedReceiver().next().toString());
            			
                		 
                		
                	}

                }
            }
            
            else block();
            }
            catch(Exception e){
            	//out.write(myAgent.getName() + " sarei morto perchè " + e.getMessage());
				//out.close();
				logger.trace("would dead because " + e.getMessage());
            }

         }
    });
  } 
  
}

