package PlatformSelector;

import jade.core.AID;
import LEARNOntology.PlatformDescription;
import LEARNOntology.impl.DefaultPlatformDescription;

public class MyPlatformDescription{

	private int numFailures=0;
	private int deadFrom=0;
	private DefaultPlatformDescription ontoP;

	public MyPlatformDescription(String name,String ip) {
		// by now, the UI can be the name (assuming that the name is unique), then we can change
		this(name, ip, 11111, name);
	}
	
	public MyPlatformDescription(String name,String ip, int port, String UI) {
		super();
		ontoP=new DefaultPlatformDescription();
		ontoP.setPlatformIP(ip);
		ontoP.setPlatformPort(port);
		ontoP.setPlatformName(name);
		ontoP.setPlatformUniqueID(UI);
		createAgents();
	}
	
	public MyPlatformDescription(DefaultPlatformDescription ontoP) {
		super();
		this.ontoP=ontoP;
		createAgents();
	}
	
	
	public DefaultPlatformDescription getOntoP() {
		return ontoP;
	}

	public AID getLEARNAMS(){
		return ontoP.getLEARNAMS();
	}
	
	public AID getSM(){
		return ontoP.getSM();
	}
	
	public void increaseNumFailures(){
		numFailures++;
	}
	
	public int getNumFailures(){
		return numFailures;
	}
	
	public int getDeadFrom() {
		return deadFrom;
	}

	public void increaseDeadFrom() {
		deadFrom++;
	}
	
	public void createAgents(){
		AID LEARNAMS = new AID("LEARNAMS@" + ontoP.getPlatformName(), true);
		LEARNAMS.addAddresses(ontoP.getPlatformIP());
		
		ontoP.setLEARNAMS(LEARNAMS);
		
		AID SM = new AID("SM@" + ontoP.getPlatformName(), true);
		SM.addAddresses(ontoP.getPlatformIP());
		ontoP.setSM(SM);
	}

	@Override
	public String toString() {
		return "PlatformDescription: IP=" + ontoP.getPlatformIP() + ", name=" + ontoP.getPlatformName() ; // + "SM " + ontoP.getSM().toString() + " LEARNAMS " + ontoP.getLEARNAMS().toString() +"]";
	}
	
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		MyPlatformDescription other = (MyPlatformDescription) obj;
		if (ontoP.getPlatformIP() == null) {
			if (other.getPlatformIP() != null)
				return false;
		} else if (!ontoP.getPlatformIP().equals(other.getPlatformIP()))
			return false;
		if (ontoP.getPlatformName() == null) {
			if (other.getPlatformName() != null)
				return false;
		} else if (!ontoP.getPlatformName().equals(other.getPlatformName()))
			return false;
		//if (port != other.port)
		//	return false;
		return true;
	}
   
	// in PlatformDescription there is no equals other than the standard one, which does not works correctly,
	// so I add this method to create a correct equals for the ontology elements
	public static boolean compareOntoPlat(PlatformDescription obj1, PlatformDescription obj2){
		if(obj1==obj2) return true;
		if(obj1==null || obj2==null) return false;
		if (obj1.getPlatformIP() == null) {
			if (obj2.getPlatformIP() != null)
				return false;
		} else if (!obj1.getPlatformIP().equals(obj2.getPlatformIP()))
			return false;
		if (obj1.getPlatformName() == null) {
			if (obj2.getPlatformName() != null)
				return false;
		} else if (!obj1.getPlatformName().equals(obj2.getPlatformName()))
			return false;
		//if (port != other.port)
		//	return false;
		return true;
	}
	
   @Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((ontoP.getPlatformIP() == null) ? 0 : ontoP.getPlatformIP().hashCode());
		result = prime * result + ((ontoP.getPlatformName() == null) ? 0 : ontoP.getPlatformName().hashCode());
		//result = prime * result + port;
		return result;
	}

	public String getPlatformIP() {
		return ontoP.getPlatformIP();
	}

	public void setPlatformIP(String platformIP) {
		ontoP.setPlatformIP(platformIP);
	}

	public int getPlatformPort() {
		return ontoP.getPlatformPort();
	}

	public void setPlatformPort(int platformPort) {
		ontoP.setPlatformPort(platformPort);
	}

	public String getPlatformName() {
		return ontoP.getPlatformName();
	}

	public void setPlatformName(String platformName) {
		ontoP.setPlatformName(platformName);
	}

	public void setPlatformUniqueID(String value) {
		ontoP.setPlatformUniqueID(value);
		
	}

	public String getPlatformUniqueID() {
		
		return ontoP.getPlatformUniqueID();
	}

	
	
}
